"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBabelConfig = ({ emitDecoratorMetadata, target, useReact }) => {
    const isTest = process.env.BABEL_ENV === 'test';
    const isDev = process.env.NODE_ENV === 'development';
    const isProd = !isTest && !isDev;
    return {
        presets: [
            ...(useReact ? ['@babel/preset-react'] : []),
            '@babel/preset-typescript',
            [
                '@babel/preset-env',
                {
                    targets: target || { node: '10.16.3' },
                    useBuiltIns: 'usage',
                    modules: isTest && 'commonjs',
                    corejs: 3,
                    loose: true
                }
            ]
        ],
        plugins: [
            ...(useReact ? ['react-hot-loader/babel'] : []),
            ...(isProd ? ['@babel/transform-react-inline-elements', '@babel/transform-react-constant-elements'] : []),
            ...(emitDecoratorMetadata ? ['babel-plugin-transform-typescript-metadata'] : []),
            '@babel/plugin-proposal-optional-catch-binding',
            '@babel/plugin-transform-modules-commonjs',
            ['@babel/plugin-proposal-decorators', { legacy: true }],
            ['@babel/plugin-proposal-class-properties', { loose: true }]
        ]
    };
};
//# sourceMappingURL=babel.js.map