import webpack from 'webpack';
interface WebpackBaseOptions {
    mode: 'development' | 'production';
    babelOptions?: any;
    outputFolder: string;
    entry: string | string[] | ObjectWithUnknownKeys;
    useReact?: boolean;
    env?: ObjectWithUnknownKeys;
    tsconfig: {
        compilerOptions?: ObjectWithUnknownKeys;
    };
}
declare type WebpackLambdaOptions = WebpackBaseOptions & {
    serverlessWebpack: any;
};
declare type WebpackWebOptions = WebpackBaseOptions & {
    devModePort?: number;
};
export declare const getWebpackWebConfig: (options: WebpackWebOptions) => webpack.Configuration;
export declare const getWebpackScriptConfig: (options: WebpackBaseOptions) => {
    mode: string;
    target: string;
    externals: any[];
    output: {
        libraryTarget: string;
        path: string;
        filename: string;
        sourceMapFilename: string;
    };
    plugins: any[];
    entry: string | ObjectWithUnknownKeys | string[];
    node: boolean;
    devtool: string;
    performance: {
        hints: boolean;
    };
    optimization: {
        noEmitOnErrors: boolean;
    };
    stats: string;
    module: {
        rules: ({
            test: RegExp;
            exclude: RegExp;
            use: {
                loader: string;
                options: any;
            };
            loader?: undefined;
            options?: undefined;
            include?: undefined;
            type?: undefined;
        } | {
            test: RegExp;
            exclude: RegExp;
            loader: string;
            options: {
                output: string;
            };
            use?: undefined;
            include?: undefined;
            type?: undefined;
        } | {
            test: RegExp;
            include: RegExp;
            type: string;
            exclude?: undefined;
            use?: undefined;
            loader?: undefined;
            options?: undefined;
        })[];
    };
    resolve: {
        extensions: string[];
        alias: {};
    };
};
export declare const getWebpackLambdaConfig: (options: WebpackLambdaOptions) => {
    target: string;
    externals: any[];
    optimization: {
        minimize: boolean;
        noEmitOnErrors: boolean;
    };
    output: {
        libraryTarget: string;
        path: string;
        filename: string;
        sourceMapFilename: string;
    };
    plugins: any[];
    entry: string | ObjectWithUnknownKeys | string[];
    node: boolean;
    devtool: string;
    mode: "development" | "production";
    performance: {
        hints: boolean;
    };
    stats: string;
    module: {
        rules: ({
            test: RegExp;
            exclude: RegExp;
            use: {
                loader: string;
                options: any;
            };
            loader?: undefined;
            options?: undefined;
            include?: undefined;
            type?: undefined;
        } | {
            test: RegExp;
            exclude: RegExp;
            loader: string;
            options: {
                output: string;
            };
            use?: undefined;
            include?: undefined;
            type?: undefined;
        } | {
            test: RegExp;
            include: RegExp;
            type: string;
            exclude?: undefined;
            use?: undefined;
            loader?: undefined;
            options?: undefined;
        })[];
    };
    resolve: {
        extensions: string[];
        alias: {};
    };
};
export declare const runWithWebpack: (filePath: string, webpackConfig: webpack.Configuration, watch: boolean, callback: Function) => void;
export {};
